///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// Copyright (C) 2006 by Intel Coproration and Carnegie Mellon University    //
// Contacts: casey.j.helfrich @ intel.com                                    //
//           bdr @ cs.cmu.edu                                                //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

#ifndef __SNOWFLAKE_H
#define __SNOWFLAKE_H

#include "CodeModule.hxx"
#include "CatomWorld.hxx"

CODE_MODULE_PROTOTYPE( Snowflake, Snowflake );
using namespace std;

extern CatomWorld *worldPtr;

class Snowflake : public CodeModule {
	int mode, old_mode;
	int wait;
public:
	Snowflake(catomID _hostCatom) :
		CodeModule(_hostCatom),mode(0)  {}
	virtual void newTick();	
	virtual void endTick();
        virtual void oracle();
};

#endif
